<template>
  <div v-if="runs" v-loading="$fetchState.pending">
    <el-table :data="runs.nodes" @row-click="clickRow">
      <el-table-column width="20px">
        <template #default="{ $index }">
          {{ $index + 1 }}
        </template>
      </el-table-column>

      <el-table-column
        prop="checkpointsCount"
        label="CPs"
        width="50px"
        align="center"
      />
      <el-table-column label="Time" width="75px">
        <template #default="{ row }">
          {{ row.totalTime | formatElapsed }}
        </template>
      </el-table-column>
      <el-table-column label="Name">
        <template #default="{ row }">
          <img
            v-if="user(row).avatarUrl"
            width="20"
            height="20"
            :src="user(row).avatarUrl"
          />
          {{ user(row).name }}
        </template>
      </el-table-column>
      <template slot="empty">
        <div v-if="runs">
          Empty!
          <nuxt-link :to="`/run/course?id=${courseId}`">Run it!</nuxt-link>
        </div>
      </template>
    </el-table>
  </div>
  <error-view v-else-if="$fetchState.error" :error="$fetchState.error" />
  <div v-else>
    {{ $fetchState }}
  </div>
</template>
<script>
import { Table, TableRow } from "element-ui";
import FetchQuery from "~/lib/fetch-query";
import { get } from "~/lib/utils";

export default {
  props: ["courseId", "count"],
  components: { "el-table": Table, "el-table-row": TableRow },
  data() {
    return { runs: null };
  },
  methods: {
    user(row) {
      return get(row, "users.nodes.0.user") || { name: "Userless" };
    },
    clickRow(row) {
      this.$router.push(`/runs/${row.id}/analyze`);
    },
  },
  fetch: FetchQuery(
    `
  query($courseId: UUID!, $first: Int! $after: Cursor) {
  runs(
    condition:{ courseId: $courseId }
    first: $first
    after: $after
    filter: { endedAt: { isNull:false }, startedAt: { isNull:false } }
    orderBy: [CHECKPOINTS_COUNT_DESC,TOTAL_TIME_ASC]
  ) {
    pageInfo {
      endCursor
    }
    nodes {
      id
      users:runUsers(first: 1) {
        nodes {
          user { name username avatarUrl }
        }
      }
      checkpointsCount
      totalTime {
        seconds
        minutes
        hours
        days
        months
        years
      }
      startedAt
      endedAt
      checkins { totalCount }
    }
  }
}
  `,
    function () {
      return { courseId: this.courseId, first: this.count };
    }
  ),
};
</script>
